;Program compiled by Great Cow BASIC (0.98.02 2018-05-10)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Chip Model: TINY44
;Assembler header file
.INCLUDE "tn44def.inc"

;SREG bit names (for AVR Assembler compatibility, GCBASIC uses different names)
#define C 0
#define H 5
#define I 7
#define N 2
#define S 4
#define T 6
#define V 3
#define Z 1

;********************************************************************************

;Register variables
.DEF	DELAYTEMP=r25
.DEF	DELAYTEMP2=r26
.DEF	SYSVALUECOPY=r21
.DEF	SYSWAITTEMPMS=r29
.DEF	SYSWAITTEMPMS_H=r30

;********************************************************************************

;Vectors
;Interrupt vectors
.ORG	0
	rjmp	BASPROGRAMSTART ;Reset
.ORG	1
	reti	;EXT_INT0
.ORG	2
	reti	;PCINT0
.ORG	3
	reti	;PCINT1
.ORG	4
	reti	;WATCHDOG
.ORG	5
	reti	;TIM1_CAPT
.ORG	6
	reti	;TIM1_COMPA
.ORG	7
	reti	;TIM1_COMPB
.ORG	8
	reti	;TIM1_OVF
.ORG	9
	reti	;TIM0_COMPA
.ORG	10
	reti	;TIM0_COMPB
.ORG	11
	reti	;TIM0_OVF
.ORG	12
	reti	;ANA_COMP
.ORG	13
	reti	;ADC
.ORG	14
	reti	;EE_RDY
.ORG	15
	reti	;USI_STR
.ORG	16
	reti	;USI_OVF

;********************************************************************************

;Start of program memory page 0
.ORG	18
BASPROGRAMSTART:
;Initialise stack
	ldi	SysValueCopy,high(RAMEND)
	out	SPH, SysValueCopy
	ldi	SysValueCopy,low(RAMEND)
	out	SPL, SysValueCopy
;Call initialisation routines
	rcall	INITSYS

;Start of the main program
;''A most simple sample for GCGB and GCB.
;''------------------------------------------------------------------------
;''This program blinks the onboard LED of a microcontroller - simple.
;''
;''This sample file can be adapted to any of the supported microcontrollers
;''by simply changing the #chip creating and removing the comment.
;''
;''To make your programmer or your bootloader work, simply do the following.
;''
;''From within this IDE, select from the menu 'IDE Tools/GCB Tools/Edit Programmer Preferences' or press Ctrl-Alt-E.
;''this will show you the 'Programmer Preferences', select the 'Programmer' tab.
;''
;''For PIC:  Typically, if you are using a PICKIT2 then 'Microchip PICKit 2 CLI - Default' will work for you.
;''For AVR:  Typically, for an UNO the programmer 'Arduino UNO/328p@115200' will work - but, please edit the communication 'PORT'.
;''then, select OK to save your changes.
;''
;''For further adventures with Great Cow BASIC .... Click button "view Demos" for 1000's of sample programs.
;''
;''
;''Enjoy.
;''
;''
;''************************************************************************
;----- Configuration
;#chip 16f877a           'Make into a comment to use the AVR chipset
;#chip mega328p, 16       'Uncomment to simply use the AVR chipset
;... helloSolenoid, and HelloEcho board
;DIR PORTA.7 OUT           'LED is output
	sbi	DDRA,7
;DIR PORTA.3 IN            'BUTTON is input
	cbi	DDRA,3
;----- Main body of program commences here.
;Do Forever
SysDoLoop_S1:
;Lighten Arduinos onboard LED for 100 milliseconds:
;PulseOut PortA.7, 100 ms   'PortA PA7, LED
;Set Pin On
	sbi	PORTA,7
;Wait Time
	ldi	SysWaitTempMS,100
	ldi	SysWaitTempMS_H,0
	rcall	Delay_MS
;Set Pin Off
	cbi	PORTA,7
;Then wait 900 milliseconds after LED goes off:
;Wait 900 ms
	ldi	SysWaitTempMS,132
	ldi	SysWaitTempMS_H,3
	rcall	Delay_MS
;Loop
	rjmp	SysDoLoop_S1
SysDoLoop_E1:
BASPROGRAMEND:
	sleep
	rjmp	BASPROGRAMEND

;********************************************************************************

Delay_MS:
	inc	SysWaitTempMS_H
DMS_START:
	ldi	DELAYTEMP2,113
DMS_OUTER:
	ldi	DELAYTEMP,58
DMS_INNER:
	dec	DELAYTEMP
	brne	DMS_INNER
	dec	DELAYTEMP2
	brne	DMS_OUTER
	dec	SysWaitTempMS
	brne	DMS_START
	dec	SysWaitTempMS_H
	brne	DMS_START
	ret

;********************************************************************************

INITSYS:
;Turn off all ports
;PORTA = 0
	ldi	SysValueCopy,0
	out	PORTA,SysValueCopy
;PORTB = 0
	ldi	SysValueCopy,0
	out	PORTB,SysValueCopy
	ret

;********************************************************************************


